diff --git a/src/main/java/net/minecraft/client/entity/particle/FlameParticle.java b/src/main/java/net/minecraft/client/entity/particle/FlameParticle.java
new file mode 100644
index 000000000..1f7b57ff3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/FlameParticle.java
@@ -0,0 +1,75 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class FlameParticle extends Particle {
+    private float oSize;
+
+    public FlameParticle(World world, double x, double y, double z, double xd, double yd, double zd, Type type) {
+        super(world, x, y, z, xd, yd, zd);
+        this.xd = this.xd * 0.01D + xd;
+        this.yd = this.yd * 0.01D + yd;
+        this.zd = this.zd * 0.01D + zd;
+        x += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
+        y += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
+        z += (this.random.nextFloat() - this.random.nextFloat()) * 0.05F;
+        this.oSize = this.size;
+        this.rCol = this.gCol = this.bCol = 1.0F;
+        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D)) + 4;
+        this.noPhysics = true;
+        this.tex = type.texture;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float s = ((float) age + partialTick) / (float) lifetime;
+        this.size = this.oSize * (1.0F - s * s * 0.5F);
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+	public float getBrightness(float partialTick) {
+        float decay = MathHelper.clamp(((float) this.age + partialTick) / (float) this.lifetime, 0.0f, 1.0f);
+        return super.getBrightness(partialTick) * decay + (1.0F - decay);
+    }
+    
+    @Override
+    public int getLightmapCoord(float partialTick) {
+    	return LightmapHelper.setBlocklightValue(super.getLightmapCoord(partialTick), 15);
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        this.move(this.xd, this.yd, this.zd);
+        this.xd *= 0.96D;
+        this.yd *= 0.96D;
+        this.zd *= 0.96D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+
+    public enum Type {
+    	ORANGE(TextureRegistry.getTexture("minecraft:particle/fire")),
+    	SOUL(TextureRegistry.getTexture("minecraft:particle/fire_soul")),
+    	BLUE(TextureRegistry.getTexture("minecraft:particle/fire_blue"));
+    	
+    	private final IconCoordinate texture;
+    	
+    	Type(IconCoordinate tex) {
+    		this.texture = tex;
+    	}
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/FootstepParticle.java b/src/main/java/net/minecraft/client/entity/particle/FootstepParticle.java
new file mode 100644
index 000000000..c512d7891
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/FootstepParticle.java
@@ -0,0 +1,63 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+import org.lwjgl.opengl.GL11;
+
+public class FootstepParticle extends Particle {
+    private int life;
+    private int lifeTime;
+    private final RenderEngine renderEngine;
+
+    public FootstepParticle(RenderEngine renderEngine, World world, double x, double y, double z) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.life = 0;
+        this.renderEngine = renderEngine;
+        this.xd = this.yd = this.zd = 0.0D;
+        this.lifeTime = 200;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float time = (life + partialTick) / lifeTime;
+        time *= time;
+        float a = 2.0F - time * 2.0F;
+        if(a > 1.0F) {
+            a = 1.0F;
+        }
+        a *= 0.2F;
+        GL11.glDisable(GL11.GL_LIGHTING);
+        float s = 0.125F;
+        float x = (float)(this.x - xOff);
+        float y = (float)(this.y - yOff);
+        float z = (float)(this.z - zOff);
+        float br = this.world.getLightBrightness(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
+        this.renderEngine.bindTexture(this.renderEngine.loadTexture("/assets/minecraft/textures/misc/footprint.png"));
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        t.startDrawingQuads();
+        t.setColorRGBA_F(br, br, br, a);
+        t.addVertexWithUV(x - s, y, z + s, 0.0D, 1.0D);
+        t.addVertexWithUV(x + s, y, z + s, 1.0D, 1.0D);
+        t.addVertexWithUV(x + s, y, z - s, 1.0D, 0.0D);
+        t.addVertexWithUV(x - s, y, z - s, 0.0D, 0.0D);
+        t.draw();
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_LIGHTING);
+    }
+
+    @Override
+	public void tick() {
+        this.life++;
+        if (this.life == this.lifeTime) {
+            this.remove();
+        }
+    }
+
+    @Override
+	public int getParticleTexture() {
+        return 3;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/GoldenArrowParticle.java b/src/main/java/net/minecraft/client/entity/particle/GoldenArrowParticle.java
new file mode 100644
index 000000000..d343798e3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/GoldenArrowParticle.java
@@ -0,0 +1,74 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+
+public class GoldenArrowParticle extends Particle {
+    float oSize;
+
+    public GoldenArrowParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        this(world, x, y, z, xa, ya, za, 1.0F);
+    }
+
+    public GoldenArrowParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd *= 0.1D;
+        this.yd *= 0.1D;
+        this.zd *= 0.1D;
+        this.xd += xa;
+        this.yd += ya;
+        this.zd += za;
+        this.rCol = gCol = 0.8f;
+        this.bCol = (float)(Math.random() * 0.3D);
+        this.size *= 0.75F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime *= (int) scale;
+        this.noPhysics = false;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float l = ((this.age + partialTick) / this.lifetime) * 32F;
+        if (l < 0.0F) {
+            l = 0.0F;
+        }
+        if (l > 1.0F) {
+            l = 1.0F;
+        }
+        this.size = this.oSize * l;
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        int val = (7 - ((this.age * 8) / this.lifetime));
+        if (val >= 0) {
+            this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + val);
+        } else {
+            this.tex = null;
+        }
+        this.yd += 0.004D;
+        this.move(this.xd, this.yd, this.zd);
+        if (this.y == this.yo) {
+            this.xd *= 1.1D;
+            this.zd *= 1.1D;
+        }
+        this.xd *= 0.96D;
+        this.yd *= 0.96D;
+        this.zd *= 0.96D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/HeartParticle.java b/src/main/java/net/minecraft/client/entity/particle/HeartParticle.java
new file mode 100644
index 000000000..161d5c441
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/HeartParticle.java
@@ -0,0 +1,64 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+
+public class HeartParticle extends Particle {
+    float oSize;
+
+    public HeartParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        this(world, x, y, z, xa, ya, za, 2.0F);
+    }
+
+    public HeartParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale)
+    {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd *= 0.01D;
+        this.yd *= 0.01D;
+        this.zd *= 0.01D;
+        this.yd += 0.1D;
+        this.size *= 0.75F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = 16;
+        this.noPhysics = false;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/heart");
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2)
+    {
+        float l = ((this.age + partialTick) / this.lifetime) * 32F;
+        if (l < 0.0F) {
+            l = 0.0F;
+        }
+        if (l > 1.0F) {
+            l = 1.0F;
+        }
+        this.size = this.oSize * l;
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        this.move(this.xd, this.yd, this.zd);
+        if (this.y == this.yo) {
+            this.xd *= 1.1D;
+            this.zd *= 1.1D;
+        }
+        this.xd *= 0.86D;
+        this.yd *= 0.86D;
+        this.zd *= 0.86D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/LavaParticle.java b/src/main/java/net/minecraft/client/entity/particle/LavaParticle.java
new file mode 100644
index 000000000..602656adf
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/LavaParticle.java
@@ -0,0 +1,59 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.world.World;
+
+public class LavaParticle extends Particle {
+    private float oSize;
+
+    public LavaParticle(World world, double x, double y, double z) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd *= 0.8D;
+        this.yd *= 0.8D;
+        this.zd *= 0.8D;
+        this.yd = this.random.nextFloat() * 0.4F + 0.05F;
+        this.rCol = this.gCol = this.bCol = 1.0F;
+        this.size *= this.random.nextFloat() * 2.0F + 0.2F;
+        this.oSize = this.size;
+        this.lifetime = (int)(16D / (Math.random() * 0.8D + 0.2D));
+        this.noPhysics = false;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/bubble_lava");
+    }
+
+    @Override
+	public float getBrightness(float partialTick) {
+        return 1.0F;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float l = (this.age + partialTick) / this.lifetime;
+        this.size = this.oSize * (1.0F - l * l);
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            remove();
+        }
+        float odds = this.age / (float) this.lifetime;
+        if (this.random.nextFloat() > odds) {
+            this.world.spawnParticle("smoke", this.x, this.y, this.z, this.xd, this.yd, this.zd, 0);
+        }
+        this.yd -= 0.03D;
+        this.move(this.xd, this.yd, this.zd);
+        this.xd *= 0.999D;
+        this.yd *= 0.999D;
+        this.zd *= 0.999D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java b/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
new file mode 100644
index 000000000..509d371b5
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
@@ -0,0 +1,95 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+
+// Referenced classes of package net.minecraft.src:
+//            EntityFX, Block, Tessellator, World
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BaseLeavesBlock;
+import net.minecraft.core.world.World;
+
+public class LeafParticle extends Particle {
+    public LeafParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        super(world, x, y, z, xa, ya, za);
+        this.tex = TextureRegistry.getTexture("minecraft:block/leaves_oak_fancy");
+        this.gravity = 0.125F;
+        this.size /= 2.0F;
+        this.lifetime *= 16;
+        this.yd = 0.0f;
+        this.xd = 0.0f;
+        this.zd = 0.0f;
+    }
+
+    @Override
+    public boolean collidesWithBlock(Block block, int metadata) {
+        return !(block instanceof BaseLeavesBlock);
+    }
+
+    public LeafParticle init(int x, int y, int z)
+    {
+        Block block = Block.blocksList[this.world.getBlockId(x, y, z)];
+        if (!(block instanceof BaseLeavesBlock)) this.remove();
+        int col = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(world, x, y, z);
+        this.rCol *= (float)(col >> 16 & 0xff) / 255F;
+        this.gCol *= (float)(col >> 8 & 0xff) / 255F;
+        this.bCol *= (float)(col & 0xff) / 255F;
+        return this;
+    }
+    
+    @Override
+	public void tick() {
+        float windDirection = this.world.worldType.getWindManager().getWindDirection(this.world, (float) this.x, (float) this.y, (float) this.z);
+        float windIntensity = this.world.worldType.getWindManager().getWindIntensity(this.world, (float) this.x, (float) this.y, (float) this.z) * 0.01f;
+
+        float dx = (float) (Math.cos(windDirection * Math.PI * 2) * windIntensity);
+        float dz = (float) (Math.sin(windDirection * Math.PI * 2) * windIntensity);
+        
+        this.xd += dx;
+        this.zd += dz;
+        
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if(this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        this.yd -= 0.04D * this.gravity;
+        if (this.onGround) {
+            this.xd *= 0.0D;
+            this.zd *= 0.0D;
+        }
+        this.move(this.xd, this.yd, this.zd);
+    }
+
+    @Override
+	public int getParticleTexture() {
+        return 1;
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
+        float u2 = (float) this.tex.getSubIconU(0.25f);
+        float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
+        float v2 = (float) this.tex.getSubIconV(0.25f);
+        float r = 0.1F * this.size;
+        float x = (float)(this.xo + (this.x - this.xo) * partialTick - LeafParticle.xOff);
+        float y = (float)(this.yo + (this.y - this.yo) * partialTick - LeafParticle.yOff);
+        float z = (float)(this.zo + (this.z - this.zo) * partialTick - LeafParticle.zOff);
+        float br = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        } else {
+        	br = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u2, v2);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java b/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
new file mode 100644
index 000000000..682ec57ea
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
@@ -0,0 +1,68 @@
+package net.minecraft.client.entity.particle;
+
+
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class NoteParticle extends Particle {
+    float oSize;
+
+    public NoteParticle(World world, double x, double y, double z, double xa, double ya, double za) {
+        this(world, x, y, z, xa, ya, za, 2.0F);
+    }
+
+    public NoteParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale) {
+        super(world, x, y, z, 0.0D, 0.0D, 0.0D);
+        this.xd *= 0.01D;
+        this.yd *= 0.01D;
+        this.zd *= 0.01D;
+        this.yd += 0.2D;
+        this.rCol = MathHelper.sin(((float)xa + 0.0F) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.gCol = MathHelper.sin(((float)xa + 1f/3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.bCol = MathHelper.sin(((float)xa + 2f/3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.size *= 0.75F;
+        this.size *= scale;
+        this.oSize = this.size;
+        this.lifetime = 6;
+        this.noPhysics = false;
+        this.tex = TextureRegistry.getTexture("minecraft:particle/note");
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        float l = ((this.age + partialTick) / this.lifetime) * 32F;
+        if (l < 0.0F) {
+            l = 0.0F;
+        }
+        if (l > 1.0F) {
+            l = 1.0F;
+        }
+        this.size = this.oSize * l;
+        super.render(t, partialTick, xa, ya, za, xa2, za2);
+    }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            this.remove();
+        }
+        this.move(this.xd, this.yd, this.zd);
+        if (this.y == this.yo) {
+            this.xd *= 1.1D;
+            this.zd *= 1.1D;
+        }
+        this.xd *= 0.66D;
+        this.yd *= 0.66D;
+        this.zd *= 0.66D;
+        if (this.onGround) {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/Particle.java b/src/main/java/net/minecraft/client/entity/particle/Particle.java
new file mode 100644
index 000000000..bd7c57556
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/Particle.java
@@ -0,0 +1,130 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.MathHelper;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.world.World;
+
+public class Particle extends Entity {
+    protected IconCoordinate tex;
+    protected float uo;
+    protected float vo;
+    protected int age;
+    protected int lifetime;
+    protected float size;
+    protected float gravity;
+    protected float rCol;
+    protected float gCol;
+    protected float bCol;
+    public static double xOff;
+    public static double yOff;
+    public static double zOff;
+
+    public Particle(World world, double x, double y, double z, double xa, double ya, double za) {
+        super(world);
+        this.age = 0;
+        this.lifetime = 0;
+        setSize(0.2F, 0.2F);
+        this.heightOffset = this.bbHeight / 2.0F;
+        setPos(x, y, z);
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.rCol = this.gCol = this.bCol = 1.0F;
+        this.xd = xa + (float)(Math.random() * 2D - 1.0D) * 0.4F;
+        this.yd = ya + (float)(Math.random() * 2D - 1.0D) * 0.4F;
+        this.zd = za + (float)(Math.random() * 2D - 1.0D) * 0.4F;
+        float speed = (float)(Math.random() + Math.random() + 1.0D) * 0.15F;
+        float dd = MathHelper.sqrt(this.xd * this.xd + this.yd * this.yd + this.zd * this.zd);
+        this.xd = (this.xd / dd) * speed * 0.4D;
+        this.yd = (this.yd / dd) * speed * 0.4D + 0.1D;
+        this.zd = (this.zd / dd) * speed * 0.4D;
+        this.uo = this.random.nextFloat() * 3F;
+        this.vo = this.random.nextFloat() * 3F;
+        this.size = (this.random.nextFloat() * 0.5F + 0.5F) * 2.0F;
+        this.lifetime = (int)(4F / (this.random.nextFloat() * 0.9F + 0.1F));
+        this.age = 0;
+    }
+
+    @Override
+    public boolean isInWaterOrRain() {
+        return false;
+    }
+
+    public Particle setPower(float power) {
+        this.xd *= power;
+        this.yd = (this.yd - 0.1D) * (double)power + 0.1D;
+        this.zd *= power;
+        return this;
+    }
+
+    public Particle setScale(float scale) {
+        setSize(0.2F * scale, 0.2F * scale);
+        this.size *= scale;
+        return this;
+    }
+
+    @Override
+	protected boolean makeStepSound() {
+        return false;
+    }
+
+    @Override
+	protected void defineSynchedData() { }
+
+    @Override
+	public void tick() {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.age++ >= this.lifetime) {
+            remove();
+        }
+        this.yd -= 0.04D * this.gravity;
+        move(this.xd, this.yd, this.zd);
+        this.xd *= 0.98D;
+        this.yd *= 0.98D;
+        this.zd *= 0.98D;
+        if (this.onGround)
+        {
+            this.xd *= 0.7D;
+            this.zd *= 0.7D;
+        }
+    }
+
+    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+        if (this.tex == null) return;
+        float u0 = (float) this.tex.getIconUMin();
+        float u2 = (float) this.tex.getSubIconU(1);
+        float v0 = (float) this.tex.getIconVMin();
+        float v2 = (float) this.tex.getSubIconV(1);
+        float r = 0.1F * this.size;
+        float x = (float)(this.xo + (this.x - this.xo) * partialTick - Particle.xOff);
+        float y = (float)(this.yo + (this.y - this.yo) * partialTick - Particle.yOff);
+        float z = (float)(this.zo + (this.z - this.zo) * partialTick - Particle.zOff);
+        float br = 1.0f;
+        if (LightmapHelper.isLightmapEnabled()) {
+        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        } else {
+        	br = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u2, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u0, v2);
+    }
+
+    public int getParticleTexture() {
+        return 0;
+    }
+
+    @Override
+	public void addAdditionalSaveData(CompoundTag tag) { }
+
+    @Override
+	public void readAdditionalSaveData(CompoundTag tag) { }
+}
